/*------------------------------------------------------------------*/
/* EvoCCs_boradcast						    */
/*   Tool for evolutionary design of broadcast-based                */
/*   collective communications on wormhole networks                 */
/*                                                                  */
/* Author: Jiri Jaros						    */
/*	   jarosjir@fit.vutbr.cz                                    */
/* 	   Brno University of Technology			    */
/* 	   GPL Licence, 2010					    */
/*------------------------------------------------------------------*/

/*------------------------------------------------------------------*/
/* MMB.h - Implementation of Many-to-Many broadcast communications  */
/*       - header file	                                            */
/*------------------------------------------------------------------*/

#ifndef MNBH
#define MNBH



#include "Chromozome.h"
#include "GeneticCore.h"
//#include "../Random.h"
#include "Statistics.h"

void   OABOnInitAlgorithm(GeneticCore& GA, int argc, char** argv);
void   MNBInitChromozome(Chromozome& chr);

double MNBFitnessFunction(Chromozome& chr);
void   MNBMutation(Chromozome& chr);

void   OABOnFinishGeneration(Statistics Stat, int ActGeneration);
void   OABOnFinish(Statistics Stat, int ActGeneration);

//---------------------------------------------------------------------------
#endif
